package ejem05;

import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
import ejem04.preDibuja;
import java.util.Vector;

public class Dibuja extends preDibuja implements ActionListener, ItemListener,
	MouseListener, MouseMotionListener {

	private Image ima;
	private Graphics g,ig;
	private int last_x = 0;
	private int last_y = 0;
	private int x0 = 0;
	private int y0 = 0;
	private int R;
	private Color drawingcolor=Color.black;
	private int state;
	private boolean fill=false, broad=false;

	private int nCrazyColor=0;
	Vector colores= new Vector();
	
	Color ColorIzq=Color.black;
	Color ColorDer=Color.black;

	static final int FREEDRAW=0;
	static final int DRAWCIRC=1;
	static final int DRAWLINE=2;
	static final int DRAWRECT=3;
	static final int ERASE=4;
	static final int CRAZYCIRC=5;
	static final int CRAZYRECT=6;
	static final int CRAZYCIRCCOLOR=7;


	public void init ()	{ 
		super.init();
		ch.addItemListener(this);
		chColorDer.addItemListener(this);
		chbxTrazo.addItemListener(this);
		chbxRelleno.addItemListener(this);
		for (int i=0;i<b.length;i++) {
			b[i].addActionListener(this);
		}
		this.addMouseListener(this);
		this.addMouseMotionListener(this);

		
		colores.addElement(Color.black);
		colores.addElement(Color.blue);
		colores.addElement(Color.cyan);
		colores.addElement(Color.darkGray);
		colores.addElement(Color.gray);
		colores.addElement(Color.green);
		colores.addElement(Color.lightGray);
		colores.addElement(Color.magenta);
		colores.addElement(Color.orange);
		colores.addElement(Color.pink);
		colores.addElement(Color.red);
		colores.addElement(Color.white);
		colores.addElement(Color.yellow);
	
	}

	public void start()	{
		state=FREEDRAW;
		g=getGraphics();
		ima=createImage(getSize().width,getSize().height);
		ig=ima.getGraphics();
		clear();
	}

	void clear() {
		ig.setColor(Color.white);
		ig.fillRect(0,0,getSize().width,getSize().height);
		ig.setColor(drawingcolor);
		g.setColor(Color.white);
		g.fillRect(0,0,getSize().width,getSize().height);
		g.setColor(drawingcolor);
		repaint();
	}


	void sello(Graphics gr,int x, int y) {
		gr.setColor(Color.white);   
		gr.fillOval(x-8,y-8,16,16); 
		gr.setColor(Color.black);   
		gr.drawOval(x-8,y-8,16,16); 
		gr.fillOval(x-4,y-4,3,3);   
		gr.fillOval(x+2,y-4,3,3);   
		gr.fillOval(x-3,y+3,6,2);   
		gr.setColor(drawingcolor);  
	}

	Color color(String name) {
		if (name.startsWith("black")) { 
			return Color.black; 
		}
		if (name.startsWith("darkGray")) { 
			return Color.darkGray; 
		}
		if (name.startsWith("gray")) { 
			return Color.gray; 
		}
		if (name.startsWith("lightGray")) { 
			return Color.lightGray; 
		}
		if (name.startsWith("red")) { 
			return Color.red; 
		}
		if (name.startsWith("blue")) { 
			return Color.blue; 
		}
		if (name.startsWith("green")) { 
			return Color.green; 
		}
		if (name.startsWith("yellow")) { 
			return Color.yellow; 
		}
		if (name.startsWith("orange")) { 
			return Color.orange; 
		}
		if (name.startsWith("white")) { 
			return Color.white; 
		} else {
			return Color.black;
		}
	}

	String xystr(int x,int y) {
		return "x="+Integer.toString(x)+" y="+Integer.toString(y);
	}

	public void paint(Graphics g) {
		if (ima!=null) { 
			g.drawImage(ima,0,0,this); 
		}
	}

	public void update(Graphics g) { 
		paint(g); 
	}

/* --------------------- Item Listener ------------------ */

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==ch) {
			drawingcolor=color(ch.getSelectedItem());
			ColorIzq=color(ch.getSelectedItem());
			g.setColor(drawingcolor);
			ig.setColor(drawingcolor);
		}else if(e.getSource()==chColorDer){
			ColorDer=color(chColorDer.getSelectedItem());
		} else if (e.getSource()==chbxTrazo) {
			fill=false;
		} else if (e.getSource()==chbxRelleno) {
			fill=true;
		}
	}

/* --------------------- Action Listener ------------------ */

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b[0]) { 
			clear(); 
		} else if (e.getSource()==b[1]) { 
			state=FREEDRAW; 
			tf[0].setText(b[1].getLabel());
		} else if (e.getSource()==b[2]) { 
			state=DRAWCIRC; 
			tf[0].setText(b[2].getLabel());
		} else if (e.getSource()==b[3]) { 
			state=DRAWLINE; 
			tf[0].setText(b[3].getLabel());
		} else if (e.getSource()==b[4]) { 
			state=DRAWRECT; 
			tf[0].setText(b[4].getLabel());
		} else if (e.getSource()==b[5]) { 
			state=CRAZYCIRC; 
			tf[0].setText(b[5].getLabel());
		} else if (e.getSource()==b[6]) { 
			state=CRAZYRECT; 
			tf[0].setText(b[6].getLabel());
		} else if (e.getSource()==b[7]) { 
			state=ERASE;     
			tf[0].setText(b[7].getLabel());
		} else if (e.getSource()==b[8]) { 
			state=CRAZYCIRCCOLOR;     
			tf[0].setText(b[8].getLabel());
		}
	}

/* --------------------- Mouse Listener ------------------ */

	public void mouseClicked(MouseEvent e) {}

	public void mousePressed(MouseEvent e) {
		
		
		if((e.getModifiers() & java.awt.event.InputEvent.BUTTON1_MASK) != 0)
			drawingcolor=ColorIzq;
		else
			drawingcolor=ColorDer;

			
		g.setColor(drawingcolor);
		ig.setColor(drawingcolor);

		int x=e.getX(), y=e.getY();
		tf[1].setText(xystr(x,y));
		if (e.getClickCount()==1) {
			last_x=x; 
			last_y=y;
			x0=x; 
			y0=y; 
			R=0;
			switch (state) { 
			case ERASE    : 
				g.setColor(Color.white);
				ig.setColor(Color.white);
			case FREEDRAW : 
				break;
			case DRAWLINE : 
				g.setXORMode(Color.white);
				g.drawLine(x0,y0,x0,y0);
				break;
			case DRAWRECT : 
				g.setXORMode(Color.white);
				g.drawRect(x0,y0,x-x0,y-y0);
				break;
			case DRAWCIRC : 
				g.setXORMode(Color.white);
				g.drawOval(x0-R,y0-R,R+R,R+R);
				break;
			case CRAZYCIRC: 
				break;
			case CRAZYRECT: 
				break;
			}
		} else if (e.getClickCount()==2) {
			sello(g,x,y); 
			sello(ig,x,y);
		}
	}

	public void mouseReleased(MouseEvent e) {
		if((e.getModifiers() & java.awt.event.InputEvent.BUTTON1_MASK) != 0)
			drawingcolor=ColorIzq;
		else
			drawingcolor=ColorDer;
			
		int x=e.getX(), y=e.getY();
		tf[1].setText(xystr(x,y));
		switch (state) { 
		case ERASE    : 
			g.setColor(drawingcolor);
			ig.setColor(drawingcolor);
		case FREEDRAW : 
			break;
		case DRAWLINE : 
			g.setPaintMode();
			g.drawLine(x0,y0,x,y); 
			ig.drawLine(x0,y0,x,y); 
			break;
		case DRAWRECT : 
			g.setPaintMode();
			if (fill) { 
				g.fillRect(x0,y0,x-x0+1,y-y0+1); 
				ig.fillRect(x0,y0,x-x0+1,y-y0+1); 
			} else { 
				g.drawRect(x0,y0,x-x0,y-y0); 
				ig.drawRect(x0,y0,x-x0,y-y0); 
			}
			break;
		case DRAWCIRC : 
			g.setPaintMode();
			R=(int)Math.sqrt((x-x0)*(x-x0)+(y-y0)*(y-y0));
			if (fill) { 
				g.fillOval(x0-R,y0-R,R+R+1,R+R+1); 
				ig.fillOval(x0-R,y0-R,R+R+1,R+R+1); 
			} else { 
				g.drawOval(x0-R,y0-R,R+R,R+R); 
				ig.drawOval(x0-R,y0-R,R+R,R+R); 
			}
			break;
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

/* --------------------- Mouse Motion Listener ------------------ */

	public void mouseMoved(MouseEvent e) {
		if((e.getModifiers() & java.awt.event.InputEvent.BUTTON1_MASK) != 0)
			drawingcolor=ColorIzq;
		else
			drawingcolor=ColorDer;

		tf[1].setText(xystr(e.getX(),e.getY()));
	}

	public void mouseDragged(MouseEvent e) {
		if((e.getModifiers() & java.awt.event.InputEvent.BUTTON1_MASK) != 0)
			drawingcolor=ColorIzq;
		else
			drawingcolor=ColorDer;

		int x=e.getX(), y=e.getY();
		int xi,yi,xf,yf;

		tf[1].setText(xystr(x,y));
		switch (state) { 
		case FREEDRAW : 
			g.drawLine(last_x,last_y,x,y);
			ig.drawLine(last_x,last_y,x,y);
			break;
		case ERASE    : 
			g.fillOval(x-8,y-8,16,16);
			ig.fillOval(x-8,y-8,16,16);
			break; 
		case DRAWLINE : 
			g.drawLine(x0,y0,last_x,last_y);
			g.drawLine(x0,y0,x,y);
			break;
		case DRAWRECT : 
			g.drawRect(x0,y0,last_x-x0,last_y-y0);
			g.drawRect(x0,y0,x-x0,y-y0);
			break;
		case DRAWCIRC : 
			g.drawOval(x0-R,y0-R,R+R,R+R);
			R=(int)Math.sqrt((x-x0)*(x-x0)+(y-y0)*(y-y0));
			g.drawOval(x0-R,y0-R,R+R,R+R);
			break;
		case CRAZYCIRC: 
			xi=Math.min(x0,x); 
			xf=Math.max(x0,x);
			yi=Math.min(y0,y); 
			yf=Math.max(y0,y);
			if (fill) { 
				g.fillOval(xi,yi,xf-xi+1,yf-yi+1); 
				ig.fillOval(xi,yi,xf-xi+1,yf-yi+1); 
			} else { 
				g.drawOval(xi,yi,xf-xi,yf-yi); 
				ig.drawOval(xi,yi,xf-xi,yf-yi); 
			}
			x0=x; 
			y0=y;
			break;
		case CRAZYCIRCCOLOR: 
			Color resp = g.getColor();
			g.setColor((Color) colores.elementAt(nCrazyColor++));
			if(nCrazyColor == colores.size()) nCrazyColor=1;
			
			xi=Math.min(x0,x); 
			xf=Math.max(x0,x);
			yi=Math.min(y0,y); 
			yf=Math.max(y0,y);
			if (fill) { 
				g.fillOval(xi,yi,xf-xi+1,yf-yi+1); 
				ig.fillOval(xi,yi,xf-xi+1,yf-yi+1); 
			} else { 
				g.drawOval(xi,yi,xf-xi,yf-yi); 
				ig.drawOval(xi,yi,xf-xi,yf-yi); 
			}
			x0=x; 
			y0=y;
			g.setColor(resp);
			break;
		case CRAZYRECT: 
			xi=Math.min(x0,x); 
			xf=Math.max(x0,x);
			yi=Math.min(y0,y); 
			yf=Math.max(y0,y);
			if (fill) { 
				g.fillRect(xi,yi,xf-xi+1,yf-yi+1); 
				ig.fillRect(xi,yi,xf-xi+1,yf-yi+1); 
			} else { 
				g.drawRect(xi,yi,xf-xi,yf-yi); 
				ig.drawRect(xi,yi,xf-xi,yf-yi); 
			}
			x0=x; 
			y0=y;
			break;
		}
		last_x=x; 
		last_y=y;
	}

}